unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Math;

type

  { TMainForm }

  TMainForm = class(TForm)
    Image: TImage;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LifeLabel: TLabel;
    ScoreLabel: TLabel;
    MenuPanel: TPanel;
    Timer: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Label5Click(Sender: TObject);
    procedure Label6Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { private declarations }
    procedure LoadGhost;
    procedure NavigateGhost;
    procedure DrawGhost;
    procedure LoadPacman;
    procedure LoadSurfaces;
    procedure LoadMap;
    procedure DrawMap;
    procedure SearchTheWay;
    procedure NewGame;
    function IsNextDotEmpty(Gx,Gy : integer; dir : byte) : boolean; // проверка след. ячейки на пустоту
    function Catched : boolean;
    //
    procedure HarvestXY(hX, hY : integer);

  public
    { public declarations }
  end; 

{описание типа для 1-го духа - ghost1 }
type TGhost = record
  x, y  : integer; // координаты (в пикселях)
  state : byte; // состояние "ауры" призрака
  direct : byte; // направление движения
  img : array [1..1] of TBitmap;
  point : TPoint;
end;

const
  PACMAN_STEP = 3; // скороть pacman'a (шаг в пикселях)
  GHOST_STEP = 2;  // скорость призрака (шаг в пикселях)
  SURF_SIZE = 30;
  ver1 = 0.45;
  ver2 = 0.9;
  nSurf = 10; // число типов поверхности
  BONUS1 = 5; // за поедание "горошины"
  BONUS2 = 25; // за поедание "таблетки"
  BONUS3 = 100; // за поедание "вкусненького"

var
  MainForm: TMainForm;
  bmp0, bmp1,bmp2 : TBitmap;
  px, py : integer;
  pacman : array [1..4,1..7] of TBitmap;
  global : byte;
  pacman_direct : byte;
  pacman_x, pacman_y : integer;
  map : array[1..17,1..21] of integer;
  way : array[1..17,1..21] of integer;
  go_left, go_right, go_up, go_down : boolean;
  surfaces : array [0..nSurf] of TBitmap; // типы поверхностей
  ghost1 : TGhost;
  total_score : integer;
  total_beens : integer;
  WLS : string;

implementation

{ TMainForm }

procedure TMainForm.NewGame;
begin
  global:=0;
  pacman_direct:=0;
  pacman_x:=300;
  pacman_y:=450;
  LoadPacman;
  LoadGhost;
  LoadSurfaces;
  LoadMap;
  go_left:=false;
  go_right:=false;
  go_up:=false;
  go_down:=false;
  Timer.Enabled:=true;
  total_score:=0;

  ScoreLabel.Caption:='';
end;

procedure TMainForm.HarvestXY(hX, hY : integer);
begin
  MainForm.Caption:=IntToStr(total_beens);
  //if total_beens=0 then begin ShowMessage('YOU WIN!'); Timer.Enabled:=false; end;;
  case map[((pacman_y+15) div 30)+1,((pacman_x+15) div 30)+1] of
   0 : begin end;
   1 : begin
         map[((pacman_y+15) div 30)+1,((pacman_x+15) div 30)+1]:=0;
         inc(total_score,BONUS1);
         dec(total_beens);
       end;
   2 : begin
         map[((pacman_y+15) div 30)+1,((pacman_x+15) div 30)+1]:=0;
         inc(total_score,BONUS2);
       end;
 3,4 : begin
         map[((pacman_y+15) div 30)+1,((pacman_x+15) div 30)+1]:=0;
         inc(total_score,BONUS3);
       end;
  end;
end;

function TMainForm.Catched : boolean;
var x1,y1, x2, y2 : integer;
begin
  Result:=false;
  x1:=(pacman_x div 30)+1;
  y1:=(pacman_y div 30)+1;
  x2:=(ghost1.x div 30)+1;
  y2:=(ghost1.y div 30)+1;
  if (x1=x2) and (y1=y2) then Result:=true;
end;

function TMainForm.IsNextDotEmpty(Gx,Gy : integer; dir : byte) : boolean; // проверка след. ячейки на пустоту
var now_x, now_y, next_x, next_y : integer;
begin
  Result:=true;
  now_x:=(Gx div 30)+1;
  now_y:=(Gy div 30)+1;
  case dir of
    1 : begin next_x:=now_x-1; next_y:=now_y; end;
    2 : begin next_x:=now_x; next_y:=now_y-1; end;
    3 : begin next_x:=now_x+1; next_y:=now_y; end;
    4 : begin next_x:=now_x; next_y:=now_y+1; end;
  end;
  if map[next_x,next_y]>9 then Result:=false;
end;

procedure TMainForm.LoadGhost; // загрузка противника
begin
  ghost1.img[1]:=TBitmap.Create;
  ghost1.img[1].LoadFromFile('images'+WLS+'ghost1-1.bmp');
  ghost1.img[1].Transparent:=true;
  ghost1.state:=1;
  ghost1.x:=300;
  ghost1.y:=210;
end;

procedure TMainForm.NavigateGhost; // управление противником
var ghost1_px_next_A, ghost1_py_next_A : byte;
    ghost1_px_next_B, ghost1_py_next_B : byte;
    ghost1_px_next_C, ghost1_py_next_C : byte;
    ghost1_px_next_D, ghost1_py_next_D : byte;
    ghost1_x_tmp, ghost1_y_tmp : integer;
    new_direction : integer;
    mg_left, mg_up, mg_right, mg_down : integer;
    prev_direct : byte;
begin
  prev_direct:=ghost1.direct;
  mg_right:=way[(ghost1.y div 30)+1,(ghost1.x div 30)+1+1];
  mg_left:=way[(ghost1.y div 30)+1,(ghost1.x div 30)+1-1];
  mg_up:=way[(ghost1.y div 30)+1-1,(ghost1.x div 30)+1];
  mg_down:=way[(ghost1.y div 30)+1+1,(ghost1.x div 30)+1];
  new_direction:=MinIntValue([mg_left,mg_up,mg_right,mg_down]);

  if new_direction=mg_left then ghost1.direct:=1;
  if new_direction=mg_up then ghost1.direct:=2;
  if new_direction=mg_right then ghost1.direct:=3;
  if new_direction=mg_down then ghost1.direct:=4;

  ghost1_x_tmp:=ghost1.x;
  ghost1_y_tmp:=ghost1.y;

  case ghost1.direct of
    1 : begin dec(ghost1_x_tmp,GHOST_STEP); end;
    2 : begin dec(ghost1_y_tmp,GHOST_STEP); end;
    3 : begin inc(ghost1_x_tmp,GHOST_STEP); end;
    4 : begin inc(ghost1_y_tmp,GHOST_STEP); end;
  end;

  ghost1_px_next_A:=(ghost1_x_tmp div 30)+1;
  ghost1_py_next_A:=(ghost1_y_tmp div 30)+1;
  ghost1_px_next_B:=((ghost1_x_tmp+29) div 30)+1;
  ghost1_py_next_B:=((ghost1_y_tmp) div 30)+1;
  ghost1_px_next_C:=((ghost1_x_tmp+29) div 30)+1;
  ghost1_py_next_C:=((ghost1_y_tmp+29) div 30)+1;
  ghost1_px_next_D:=((ghost1_x_tmp) div 30)+1;
  ghost1_py_next_D:=((ghost1_y_tmp+29) div 30)+1;

  if (map[ghost1_py_next_A,ghost1_px_next_A]>9) or
     (map[ghost1_py_next_B,ghost1_px_next_B]>9) or
     (map[ghost1_py_next_C,ghost1_px_next_C]>9) or
     (map[ghost1_py_next_D,ghost1_px_next_D]>9) then ghost1.direct:=prev_direct;

  case ghost1.direct of
    0 : {stop}Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
    1 : {left}
        begin
          dec(ghost1.x,GHOST_STEP);
          Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
        end;
    2 : {up}
        begin
          dec(ghost1.y,GHOST_STEP);
          Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
        end;
    3 : {right}
        begin
          inc(ghost1.x,GHOST_STEP);
          Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
        end;
    4 : {down}
        begin
          inc(ghost1.y,GHOST_STEP);
          Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
        end;
    5 : {ignore}begin end;
  end;
end;

procedure TMainForm.DrawGhost;
begin
  //Image.Canvas.Rectangle(ghost1.x,ghost1.y,ghost1.x+30,ghost1.y+30);
  Image.Canvas.Draw(ghost1.x,ghost1.y,ghost1.img[1]);
end;

procedure TMainForm.LoadPacman;
var i, j : integer;
begin
  for j:=1 to 4 do
  for i:=1 to 7 do
  begin
    pacman[j,i]:=TBitmap.Create;
    pacman[j,i].LoadFromFile('images'+WLS+'pacman'+IntToStr(j)+'-'+IntToStr(i)+'.bmp');
    pacman[j,i].Transparent:=true;
  end;
end;

procedure TMainForm.LoadSurfaces; // загрузка типов поверхностей
var i : integer;
begin
  for i:=0 to nSurf do
  begin
    surfaces[i]:=TBitmap.Create;
    surfaces[i].LoadFromFile('images'+WLS+'surfaces'+WLS+IntToStr(i)+'.bmp');
  end;
end;

procedure TMainForm.LoadMap; // загрузка карты
var i, j : integer;
    f : textfile;
begin
  //total_beens:=0;
  AssignFile(f,'maps'+WLS+'0.map');
  Reset(f);
  for j:=1 to 17 do
  begin
    for i:=1 to 21 do
    Read(f,map[j,i]);
    ReadLn(f);
  end;
  CloseFile(f);

  {for j:=1 to 17 do
   for i:=1 to 21 do
   if map[j,i]=0 then inc(total_beens);
   ShowMessage(IntToStr(total_beens)); }
end;

procedure TMainForm.DrawMap;
var i, j : integer;
begin
  with Image.Canvas do
  for j:=1 to 17 do
   for i:=1 to 21 do
    Draw((i-1)*30,(j-1)*30,surfaces[map[j,i]]);
end;

procedure TMainForm.SearchTheWay;
var i, j : integer;
    target : boolean;
    step : integer;
begin
  if Catched then begin Timer.Enabled:=false; ShowMessage('GAME OVER'); MenuPanel.Show; exit; end;
  way:=map; // карта путей идентична видимой карте
  for j:=1 to 17 do
  for i:=1 to 21 do
   if way[j,i] in [1..9] then way[j,i]:=0;
  //
  way[(ghost1.y div 30)+1,(ghost1.x div 30)+1]:=-999;
  way[(pacman_y div 30)+1,(pacman_x div 30)+1]:=-1;
  step:=-1;
  target:=false;
  with Image.Canvas do
  repeat
   for j:=1 to 17 do
   for i:=1 to 21 do
    begin
    if (way[j,i]=step) then
      begin
        if way[j-1,i]=0 then way[j-1,i]:=step-1;
        if way[j+1,i]=0 then way[j+1,i]:=step-1;
        if way[j,i-1]=0 then way[j,i-1]:=step-1;
        if way[j,i+1]=0 then way[j,i+1]:=step-1;
        //
        if way[j-1,i]=-999 then target:=true;
        if way[j+1,i]=-999 then target:=true;
        if way[j,i-1]=-999 then target:=true;
        if way[j,i+1]=-999 then target:=true;
      end;
      //if way[j,i]<0 then TextOut((i-1)*30+7,(j-1)*30+7,IntToStr(way[j,i]));
      end;
      dec(step);
  until target;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
var pacman_px_next_A, pacman_py_next_A : byte;
    pacman_px_next_B, pacman_py_next_B : byte;
    pacman_px_next_C, pacman_py_next_C : byte;
    pacman_px_next_D, pacman_py_next_D : byte;
    pacman_x_tmp, pacman_y_tmp : integer;
begin
  ScoreLabel.Caption:='SCORE : '+IntToStr(total_score);
  DrawMap;
  SearchTheWay;
  NavigateGhost;
  DrawGhost;
  inc(global); // увеличиваем счетчик состояния pacman'a
  {вычисляем следующие координаты углов pacman'a}
  pacman_x_tmp:=pacman_x;
  pacman_y_tmp:=pacman_y;
  {GO_LEFT - движение/поворот влево}
  pacman_px_next_A:=(pacman_x_tmp div 30);
  pacman_py_next_A:=(pacman_y_tmp div 30)+1;
  pacman_px_next_D:=((pacman_x_tmp) div 30);
  pacman_py_next_D:=((pacman_y_tmp+29) div 30)+1;
  if (map[pacman_py_next_A,pacman_px_next_A]<=9) and
     (map[pacman_py_next_D,pacman_px_next_D]<=9) and (go_left=true) then
      pacman_direct:=1;
  {GO_UP - движение/поворот вверх}
  pacman_px_next_A:=(pacman_x_tmp div 30)+1;
  pacman_py_next_A:=(pacman_y_tmp div 30);
  pacman_px_next_B:=((pacman_x_tmp+29) div 30)+1;
  pacman_py_next_B:=((pacman_y_tmp) div 30);
  if (map[pacman_py_next_A,pacman_px_next_A]<=9) and
     (map[pacman_py_next_B,pacman_px_next_B]<=9) and (go_up=true) then
      pacman_direct:=2;
  {GO_RIGHT - движение/поворот вправо}
  pacman_px_next_B:=((pacman_x_tmp+29) div 30)+2;
  pacman_py_next_B:=((pacman_y_tmp) div 30)+1;
  pacman_px_next_C:=((pacman_x_tmp+29) div 30)+2;
  pacman_py_next_C:=((pacman_y_tmp+29) div 30)+1;
  if (map[pacman_py_next_B,pacman_px_next_B]<=9) and
     (map[pacman_py_next_C,pacman_px_next_C]<=9) and (go_right=true) then
      pacman_direct:=3;
  {GO_DOWN - движение/поворот вниз}
  pacman_px_next_C:=((pacman_x_tmp+29) div 30)+1;
  pacman_py_next_C:=((pacman_y_tmp+29) div 30)+2;
  pacman_px_next_D:=((pacman_x_tmp) div 30)+1;
  pacman_py_next_D:=((pacman_y_tmp+29) div 30)+2;
  if (map[pacman_py_next_C,pacman_px_next_C]<=9) and
     (map[pacman_py_next_D,pacman_px_next_D]<=9) and (go_down=true) then
      pacman_direct:=4;
  //
  case pacman_direct of // получаем данные для след.шага
    0 : {stop} begin end;
    1 : {left} dec(pacman_x_tmp,PACMAN_STEP);
    2 : {up} dec(pacman_y_tmp,PACMAN_STEP);
    3 : {right} inc(pacman_x_tmp,PACMAN_STEP);
    4 : {down} inc(pacman_y_tmp,PACMAN_STEP);
    5 : {ignore} begin end;
  end;
  {вычисляем следующие координаты углов pacman'a}
  pacman_px_next_A:=(pacman_x_tmp div 30)+1;
  pacman_py_next_A:=(pacman_y_tmp div 30)+1;
  pacman_px_next_B:=((pacman_x_tmp+29) div 30)+1;
  pacman_py_next_B:=((pacman_y_tmp) div 30)+1;
  pacman_px_next_C:=((pacman_x_tmp+29) div 30)+1;
  pacman_py_next_C:=((pacman_y_tmp+29) div 30)+1;
  pacman_px_next_D:=((pacman_x_tmp) div 30)+1;
  pacman_py_next_D:=((pacman_y_tmp+29) div 30)+1;
  {проеверяем клетку след.шага на доступность (пусто/стена)}
  if (map[pacman_py_next_A,pacman_px_next_A]>9) or
     (map[pacman_py_next_B,pacman_px_next_B]>9) or
     (map[pacman_py_next_C,pacman_px_next_C]>9) or
     (map[pacman_py_next_D,pacman_px_next_D]>9) then pacman_direct:=0; // если встретили стену - останавливаемся
  case pacman_direct of
    0 : {stop}Image.Canvas.Draw(pacman_x,pacman_y,pacman[1,global]);
    1 : {left}
        begin
          dec(pacman_x,PACMAN_STEP);
          Image.Canvas.Draw(pacman_x,pacman_y,pacman[1,global]);
          HarvestXY(pacman_x,pacman_y);
        end;
    2 : {up}
        begin
          dec(pacman_y,PACMAN_STEP);
          Image.Canvas.Draw(pacman_x,pacman_y,pacman[2,global]);
          HarvestXY(pacman_x,pacman_y);
        end;
    3 : {right}
        begin
          inc(pacman_x,PACMAN_STEP);
          Image.Canvas.Draw(pacman_x,pacman_y,pacman[3,global]);
          HarvestXY(pacman_x,pacman_y);
        end;
    4 : {down}
        begin
          inc(pacman_y,PACMAN_STEP);
          Image.Canvas.Draw(pacman_x,pacman_y,pacman[4,global]);
          HarvestXY(pacman_x,pacman_y);
        end;
    5 : {ignore}begin end;
  end;
  if global=7 then global:=0; // если достигнуто max.состояние для pacman'a, то начинаем с начала
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Randomize;
  //NewGame;
  total_score:=0;
  total_beens:=0;
  {$IFDEF linux}
    WLS:='/';
  {$ENDIF}
  {$IFDEF windows}
   WLS:='\';
  {$ENDIF}
end;

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  case key of
    37 : go_left:=true;
    38 : go_up:=true;
    39 : go_right:=true;
    40 : go_down:=true;
  end;
end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: char);
begin
  case key of
    #27 : {esc} begin
                  if MenuPanel.Visible then
                  begin
                    MenuPanel.Hide;
                    Timer.Enabled:=true;
                  end
                  else
                  begin
                    MenuPanel.Show;
                    Timer.Enabled:=false;
                  end;
                end;

    #32 : {' '} LoadMap;
  end;
end;

procedure TMainForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ShowMessage(IntToStr(key));
  case key of
    37 : go_left:=false;
    38 : go_up:=false;
    39 : go_right:=false;
    40 : go_down:=false;
  end;
end;

procedure TMainForm.Label5Click(Sender: TObject);
begin
  MenuPanel.Hide;
  NewGame;
end;

procedure TMainForm.Label6Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
end;

procedure TMainForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
end;

initialization
  {$I main.lrs}

end.

